<%@ Page Language="C#" 
    MasterPageFile="~/Resources/MasterPages/Modal.Master" 
    CodeBehind="CreateNewAction.aspx.cs" 
    Inherits="Inedo.BuildMaster.Web.WebApplication.Applications.Plans.CreateNewAction" 
    Title="Add New Action"
    %>
<asp:Content runat="server" ID="AdditionalHeadContent" ContentPlaceHolderID="AdditionalHeadContent">
    <style type="text/css">
    .actionType:hover { background-color: #EAEAEA; cursor: pointer; }
    </style>

    <style type="text/css">
        #ActionSelect { }
        #ActionSelect #Categories {float:left;width:200px;padding:10px 0px 30px 0px;margin-top:15px;background-color:#DDD;}
        #ActionSelect #ActionsOuter {float:right;margin-left:-210px;width:100%;}
        #ActionSelect #Actions {margin-left:201px;padding:5px 20px 10px 10px;min-height:350px;}
        
        #ActionSelect #Actions{border:solid 1px #999;}
        #ActionSelect #Categories {border:solid 1px #999;}
        
        #ActionSelect #Categories UL {list-style:none; margin:0px; padding:0px;border-top:solid 1px #AAA;cursor: pointer;}
        #ActionSelect #Categories UL LI {list-style:none;display:block;margin:0px;padding: 5px 10px;font-weight: bold;border-bottom:solid 1px #AAA;}
        #ActionSelect #Categories UL LI a {text-decoration: none; color: #333;}
        #ActionSelect #Categories UL LI.selected {background-color:#FFF; margin-right:-1px;}
        
        #ActionSelect #Actions UL {list-style:none; margin:0px; padding:0px;}
        #ActionSelect #Actions UL LI {list-style:none;display:block;margin:0px;padding:10px;}

    </style>
    <!--[if lt IE 7]><style>#ActionSelect #Categories UL LI {height: 0;}</style><![endif]-->
    <!--[if IE 7]><style>#ActionSelect #Categories UL LI {zoom: 1;}</style><![endif]-->
    <script type="text/javascript">
        $(document).ready(function(){
            var catSelect = '#ActionSelect #Categories UL LI:visible';
            var actSelect = '#ActionSelect #Actions UL LI';
            
            $(catSelect).each(function(idx, el){
                
                var selected = $(el).hasClass('selected');
                $(el).removeClass('selected');
                
                var catIdx = el.className;
                el.className = selected ? 'selected' : '';
                
                <% if (string.IsNullOrEmpty(catIdx)) { %>
                if (idx == 0)
                {
                    $(el).addClass('selected');
                    $(actSelect+'.'+catIdx).show();                    
                }
                <% } %>
                
                var timeOut;
                $(this).bind('mouseenter', function(evt){
                    
                    var el = this;
                    timeOut = window.setTimeout(function(){
                        $(actSelect).hide();
                        $(catSelect).removeClass('selected');
                        
                        $(el).toggleClass('selected');
                        $(actSelect+'.' + catIdx).show();
                    },50);
                });
                $(this).bind('mouseleave', function(evt){
                    window.clearTimeout(timeOut);
                });
            });
        });
    </script>
    
</asp:Content>
<asp:Content ID="MainContent" ContentPlaceHolderID="MainContent" runat="server">
    <h1><%=Title %></h1>
    <div class="subH1">Select the action to execute </div>
    
    <div id="ActionSelect" style="margin:10px 0px;">
        <div id="ActionsOuter" style="">
            <div id="Actions">
                <ul>
            <asp:Repeater runat="server" ID="rptActions">
                <ItemTemplate>
                    <li class="actionType <%#getCategoryIndex(Container.DataItem) %>" onclick="location='<%#getUrl(Container.DataItem) %>';"  style="display:<%#getCategoryIndex(Container.DataItem).Equals(catIdx) ? "block" : "none" %>">
                        <div class="headingWrap">
                            <h3><%#Eval(TableDefs2.ActionTypes.Action_Name) %></h3>
                            <noscript><a href="<%#getUrl(Container.DataItem) %>">[select]</a></noscript>
                        </div>
                        <div class="subH3">
                        <%# Eval(TableDefs2.ActionTypes.Action_Description) %>
                        </div>
                    </li>
                </ItemTemplate>
            </asp:Repeater>
                </ul>
            </div>
        </div>
        <div id="Categories">
            <ul>
                <li style="display:none"><!-- IE7 Workaround: Negative Margin doesn't work on first LI --></li>
            <asp:Repeater runat="server" ID="rptCategories">
                <ItemTemplate>
                    <li class="<%#getCategoryIndex((string)Container.DataItem)%><%#catIdx.Equals(getCategoryIndex((string)Container.DataItem))?" selected" : "" %>">
                        <%#Container.DataItem%>
                    </li>
                </ItemTemplate>
            </asp:Repeater>
            </ul>
        </div>        
        <div style="clear:both;"></div>
    </div>

    <script runat="server" type="text/C#">
        string getCategoryIndex(string catName)
        {
            return string.Format("C{0}",categoryNames.IndexOf(catName));
        }
        string getCategoryIndex(object objDr)
        {
            DataRowView dr = (DataRowView)objDr;
            return getCategoryIndex(dr[TableDefs2.ActionTypes.Category_Name].ToString());
        }
        
        string getUrl(object dr)
        {
            Type type = (Type)((DataRowView)dr)[TableDefs2.ActionTypes.Action_Type];
            if (Util.Reflection.GetGenericArgumentsFromAncestor(type, typeof(Inedo.BuildMaster.Extensibility.Actions.ProviderBasedAction<>)).Length > 0)
            {
                return
                    "SelectProvider.aspx?planActionGroupId=" + planActionGroupId.ToString()
                    + "&actionType="
                    + HttpUtility.UrlEncode(
                        type.FullName
                        + ","
                        + type.Assembly.GetName().Name
                    );                
            }
            else if (type.IsSubclassOf(typeof(Inedo.BuildMaster.Extensibility.Actions.AgentBasedActionBase)))
            {
                Inedo.BuildMaster.Extensibility.Actions.ActionPropertiesAttribute props = 
                    Util.Reflection.GetCustomAttribute<Inedo.BuildMaster.Extensibility.Actions.ActionPropertiesAttribute>(type);
                if (props != null && props.DefaultToLocalServer)
                {
                    return
                         "EditAction.aspx?planActionGroupId=" + planActionGroupId.ToString()
                         + "&serverId=1"
                         + "&actionType="
                         + HttpUtility.UrlEncode(
                             type.FullName
                             + ","
                             + type.Assembly.GetName().Name
                         );                    
                }
                else
                {
                    return
                        "SelectServer.aspx?planActionGroupId=" + planActionGroupId.ToString()
                        + "&actionType="
                        + HttpUtility.UrlEncode(
                            type.FullName
                            + ","
                            + type.Assembly.GetName().Name
                        );
                }
            }
            else
                return
                    "EditAction.aspx?planActionGroupId=" + planActionGroupId.ToString()
                    + "&actionType="
                    + HttpUtility.UrlEncode(
                        type.FullName
                        + ","
                        + type.Assembly.GetName().Name
                    );
        }
    </script>    



        
</asp:Content>
