﻿(function ($) {
    if (!$ || !$.ui || !$.ui.dialog) { alert('Error: JQuery.UI.Dialog library not loaded; cannot add inedobm_actionserverpicker plugin.'); return false; }

    $.fn.inedobm_actionserverpicker = function (o) {
        /// <param name="o" value="{servers:[{id:'',text:''}]}"/>

        var formatSelection = function (item) {
            var container = $('<div class="server-picker-item"></div>');
            var imgUrl = '/resources/images/icons/';

            if (item.id == '1')
                imgUrl += 'primaryservericon.svg';
            else if (item.group)
                imgUrl += 'servergroupicon.svg';
            else if (item.id.length > 0 && item.id[0] == '%')
                imgUrl += 'variableserver.svg';
            else
                imgUrl += 'servericon.svg';

            container.append($('<img width="16" height="16" />').attr('src', imgUrl));

            var desc = $('<span></span>');
            desc.text(' ' + item.text);
            container.append(desc);
            return container;
        };

        $(this).select2({
            width: '300px',
            data: o.servers,
            formatSelection: formatSelection,
            formatResult: function (item) {
                if (item.children) {
                    var titleContainer = $('<div></div>');
                    titleContainer.append($('<strong></strong>').text(item.text));
                    return titleContainer;
                }
                else {
                    return formatSelection(item);
                }
            },
            createSearchChoice: function (term) {
                /// <param name="term" value="''"/>
                var varRegex = /^%[^%]+%$/;
                if (varRegex.test(term))
                    return { id: term, text: term };
                else
                    return null;
            }
        });
    };
})(jQuery);