﻿(function ($) {
    if (!$ || !$.ui || !$.ui.sortable) { alert('Error: JQuery.UI.Sortable library not loaded; cannot add inedobm_sortableex plugin.'); return false; }

    var SID = 'inedobm_sortableex_idx';
    var SEQ = 'inedobm_sortableex_seq';

    $.fn.inedobm_sortableex = function (swapHandler, o) {

        o = $.extend({
            identifiers: null,
            ajaxData: null,
            items: '> *',
            handle: false
        }, o);

        var $this = this;
        var $items = $(o.items, $this);

        if (!o.handle) {
            $items.css('cursor', 'move');
        }

        // add identifier attributes
        if (o.identifiers) {
            $items.each(function (idx, el) {
                $(el).attr(SID, o.identifiers[idx]);
            });
        }

        // add sequence attributes
        var setSequences = function ($items) {
            $items.each(function (idx, el) {
                $(el).attr(SEQ, idx + 1);
            });
        };
        setSequences($items);

        $(this)
            .sortable({
                items: o.items,
                handle: o.handle,

                //helper: function (e, ui) {
                //    // handle table row resizing
                //    ui.filter('tr').children().each(function () {
                //        $(this).width($(this).width());
                //    });
                //    return ui;
                //},

                update: function (e, ui) {

                    var idx = (function () {
                        var ret = -1;
                        $(o.items, $this).each(function (idx, el) { if (el == ui.item[0]) ret = idx; });
                        return ret;
                    })();

                    var id = ui.item.attr(SID) || ui.item.attr(SEQ);
                    var swappedId = $items.eq(idx).attr(SID) || $items.eq(idx).attr(SEQ);

                    $.ajax({
                        type: 'POST',
                        async: false,
                        url: swapHandler,
                        data: $.extend({ id: id, swappedId: swappedId, idx: idx }, o.ajaxData),
                        success: function (data) {
                            $items = $(o.items, $this);
                            setSequences($items);

                            // reorder tables
                            ui.item.parent('tbody').parent('table.styled-table').find('tbody tr').each(function (idx, el) {
                                $(el).removeClass().addClass(idx % 2 ? 'even' : 'odd');

                                // hack to replace Seq values...
                                var href = $(el).find('a').each(function (a_idx, a_el) {
                                    var href = $(a_el).attr('href');
                                    $(a_el).attr('href', href.replace(/Seq=\d+/, 'Seq=' + idx));
                                });
                            });
                        },
                        error: function (data) {
                            alert((data.status == 404) ? 'The swapHandler was not found (404).' : 'The server returned an error: ' + data.responseText);
                            $(this).sortable('cancel');
                        }
                    });
                } //update
            })
            .disableSelection();

        return this;
    };

})(jQuery);
