﻿(function ($) {
    if (!$ || !$.ui || !$.ui.tabs) { alert('Error: JQuery.UI.Tabs library not loaded; cannot add inedobm_tabbeddeploymentplans plugin.'); return false; }

    $.fn.inedobm_tabbeddeploymentplans = function (o) {

        var getQuerystring = function (key) {
            key = key.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
            var regex = new RegExp("[\\?&]" + key + "=([^&#]*)");
            var qs = regex.exec(window.location.href);
            if (qs == null) {
                return undefined;
            }
            else {
                return qs[1];
            }
        };

        $('div.admin-container').hover(function () {
            $(this).find('img').stop().animate({ opacity: 1 });
        }, function () {
            $(this).find('img').stop().animate({ opacity: 0.4 });
        });

        var zebraStripe = function () {
            $('.actions > ol > li').removeClass('even');
            $('.actions > ol > li:even').addClass('even');
        };

        zebraStripe();

        $('.action-group-heading .toggle').click(function () {
            $toggleButton = $(this);
            $parentActionGroup = $(this).closest('li');
            $parentActionGroup.find('.action-group-predicates,.actions').toggle('slow', function () {
                if ($(this).is(':visible')) {
                    $toggleButton.removeClass('collapsed');
                }
                else {
                    $toggleButton.addClass('collapsed');
                }
            });
            return false;
        });

        var $tabs = $(this).tabs({
            beforeActivate: function (event, ui) {
                // manually append the hash sign to the URL to force tab selection on reload of same page
                window.location = ui.newPanel.selector;
            }
        });

        // preselect the environment tab if it exists in the query string
        var environmentId = getQuerystring('environmentId');
        if (environmentId !== undefined) {
            var $item = $('li#environment-' + environmentId);
            $tabs.tabs('select', $('ul:first li', $tabs).index($item));
        }

        var receivedFromDifferentList = false;
        $('.actions ol').sortable({
            handle: "p.handle",
            //connectWith: ".connectedSortable", // moved to bottom - see http://bugs.jqueryui.com/ticket/4759
            tolerance: "pointer",
            receive: function (event, ui) {
                receivedFromDifferentList = true;
            },
            update: function (event, ui) {
                $targetActionList = ui.item.parent('ol');

                var planActionGroupId = parseInt(ui.item.prop('id').split('-')[2]);
                var actionSequence = parseInt(ui.item.prop('id').split('-')[3]);
                var newActionSequence = ui.item.prevAll(':not(.no-actions)').length + 1;
                var newPlanActionGroupId = parseInt(ui.item.parent('ol').attr('id').split('-')[4]);

                if (planActionGroupId == newPlanActionGroupId) {
                    $.ajax({
                        url: o.resequenceActionUrl + "?planActionGroupId=" + planActionGroupId + "&actionSequence=" + actionSequence + "&newActionSequence=" + newActionSequence + "&applicationId=" + o.applicationId,
                        async: false,
                        type: 'POST',
                        success: function (data) {
                            // refresh the ids with the new sequences of the actions in the group
                            $targetActionList.children("li").each(function (index) {
                                $(this).prop('id', 'action-sequence-' + planActionGroupId + '-' + (index + 1));
                                // replace all admin-container links with the appropriate new action sequence
                                $(this).find('.admin-container a').each(function () {
                                    var href = $(this).prop('href');
                                    var newHref = href.replace(/actionSeq=\d+/, 'actionSeq=' + (index + 1));
                                    $(this).prop('href', newHref);
                                });
                            });
                        },
                        error: function (data) {
                            alert('There was an error moving the action: ' + data.responseText);
                        }
                    });
                }
                else if (receivedFromDifferentList) {
                    receivedFromDifferentList = false;
                    $.ajax({
                        url: o.changeActionGroupUrl + "?planActionGroupId=" + planActionGroupId + "&actionSequence=" + actionSequence + "&newPlanActionGroupId=" + newPlanActionGroupId + "&newActionSequence=" + newActionSequence + "&applicationId=" + o.applicationId,
                        async: false,
                        type: 'POST',
                        success: function (data) {
                            // refresh the ids with the new sequences of the actions in the group
                            $targetActionList.children("li:not(.no-actions)").each(function (index) {
                                $(this).prop('id', 'action-sequence-' + newPlanActionGroupId + '-' + (index + 1));
                                $(this).find('.admin-container a').each(function () {
                                    var href = $(this).prop('href');
                                    var newHref = href.replace(/planActionGroupId=\d+&actionSeq=\d+/, 'planActionGroupId=' + newPlanActionGroupId + '&actionSeq=' + (index + 1));
                                    $(this).prop('href', newHref);
                                });
                            });

                            $('#plan-action-group-actions-' + planActionGroupId).children("li").each(function (index) {
                                $(this).prop('id', 'action-sequence-' + planActionGroupId + '-' + (index + 1));
                                $(this).find('.admin-container a').each(function () {
                                    var href = $(this).prop('href');
                                    var newHref = href.replace(/planActionGroupId=\d+&actionSeq=\d+/, 'planActionGroupId=' + planActionGroupId + '&actionSeq=' + (index + 1));
                                    $(this).prop('href', newHref);
                                });
                            });

                            $targetActionList.find('li.no-actions').remove();
                            $('.actions ol:not(:has(li))').append('<li class="no-actions">There are no actions for this action group.</li>');
                        },
                        error: function (data) {
                            alert('There was an error moving the action: ' + data.responseText);
                            
                            // the droppable component will not put the action group back to where it was, easiest just to refresh
                            window.location.reload();
                        }
                    });
                }

                zebraStripe();
            }
        }).sortable("option", "connectWith", '.connectedSortable');

        $(".action-groups").sortable({
            handle: "p.handle:first",
            update: function (event, ui) {
                var planActionGroupId = parseInt(ui.item.prop('id').split('-')[3]);
                var newPlanActionGroupSequence = ui.item.prevAll().length + 1;

                $.ajax({
                    url: o.resequenceActionGroupUrl + "?planActionGroupId=" + planActionGroupId + "&newPlanActionGroupSequence=" + newPlanActionGroupSequence + "&applicationId=" + o.applicationId,
                    async: false,
                    type: 'POST',
                    success: function (data) {

                    },
                    error: function (data) {
                        alert('There was an error moving the action group: ' + data.responseText);
                    }
                });
            }
        }).disableSelection();

        var $tab_items = $("ul:first li", $tabs).droppable({
            accept: "ul.action-groups > li",
            hoverClass: "ui-state-hover",
            tolerance: "pointer",
            drop: function (event, ui) {
                var $item = $(this);
                var $list = $($item.find("a").attr("href"))
                        .find(".action-groups");

                ui.draggable.hide("slow", function () {
                    $listItem = $(this);
                    var planActionGroupId = parseInt(ui.draggable.attr('id').split('-')[3]);
                    var newEnvironmentId = parseInt($item.attr('id').split('-')[1]);

                    $.ajax({
                        url: o.changeActionGroupEnvironmentUrl + "?planActionGroupId=" + planActionGroupId + "&environmentId=" + newEnvironmentId + '&applicationId=' + o.applicationId,
                        async: false,
                        type: 'POST',
                        success: function (data, textStatus, jqXHR) {
                            $tabs.tabs("select", $tab_items.index($item));
                            $listItem.css('height', 'auto');
                            $listItem.appendTo($list).show("slow");
                            // new item incoming, remove the "no action groups" message
                            $list.find('.no-action-groups').remove();
                            // environments with no action groups should now display the "no action groups" message
                            $('ul.action-groups:not(:has(li))').append('<li class="no-action-groups">There are no action groups for this environment.</li>');
                        },
                        error: function (data) {
                            alert('There was an error moving the action group: ' + data.responseText);

                            // the droppable component will not put the action group back to where it was, easiest just to refresh
                            window.location.reload();
                        }
                    });
                });
            }
        });

        return this;
    };
})(jQuery);